const { series, parallel, src, dest, watch } = require('gulp');
const sass = require('gulp-sass')(require('sass'));
const ejs = require("gulp-ejs");


function sassBuild(cb) {
    return src('./src/themes/**/index.scss')
        .pipe(sass().on('error', sass.logError))
        .pipe(dest('./dist/themes'));
}

function ejsExamples(cb) {
    console.log(`apollo URL in use is ${process.env.APOLLO_URL}`);

    src("./examples/*.ejs")
        .pipe(ejs({
            forms: [
                { name: 'Success Form', id: '1' }
            ],
            apollo_url: process.env.APOLLO_URL,
            recaptcha_site_key: process.env.RECAPTCHA_SITE_KEY
        }, {}, { ext: '.html' }))
        .pipe(dest("./dist"))
}


exports.dev = function() {
    watch('./src/themes/**/*.scss', sassBuild);
    watch('./examples/index.ejs', ejsExamples);
};

exports.default = sassBuild;