'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.API = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ajax = require('./ajax');

var _ajax2 = _interopRequireDefault(_ajax);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var API = function () {
    function API(_ref) {
        var apollo = _ref.apollo,
            apiRoot = _ref.apiRoot;

        _classCallCheck(this, API);

        this.apollo = apollo;
        this.root = apiRoot;
    }

    _createClass(API, [{
        key: 'ajaxRequest',
        value: function ajaxRequest(path) {
            var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            var url = this.apollo + this.root + path;
            (0, _ajax2.default)(url, opts);
        }
    }, {
        key: 'get',
        value: function get(path, _ref2) {
            var callback = _ref2.callback,
                error = _ref2.error;

            this.ajaxRequest(path, {
                method: 'GET',
                callback: callback,
                error: error
            });
        }
    }, {
        key: 'post',
        value: function post(path, _ref3) {
            var callback = _ref3.callback,
                error = _ref3.error,
                params = _ref3.params;

            this.ajaxRequest(path, {
                method: 'POST',
                bodyParams: JSON.stringify(params),
                headers: { 'Content-Type': 'application/json', Accept: 'application/json' },
                callback: callback,
                error: error
            });
        }
    }, {
        key: 'crud',
        value: function crud(basePath) {
            var _this = this;

            var allowedMethods = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

            var CrudMethods = {
                get: function get(objId, _ref4) {
                    var callback = _ref4.callback,
                        error = _ref4.error;
                    return _this.get(basePath + '/' + objId, { callback: callback, error: error });
                },
                create: function create(params, _ref5) {
                    var callback = _ref5.callback,
                        error = _ref5.error;
                    return _this.post(basePath, { callback: callback, error: error, params: params });
                }
            };

            Object.keys(CrudMethods).filter(function (m) {
                return allowedMethods.indexOf(m) < 0;
            }).forEach(function (disallowedMethod) {
                CrudMethods[disallowedMethod] = function () {
                    throw new Error(disallowedMethod + ' isnt an allowed method for ' + basePath);
                };
            });

            return CrudMethods;
        }
    }]);

    return API;
}();

var apiFactory = function apiFactory(_ref6) {
    var apollo = _ref6.apollo,
        apiRoot = _ref6.apiRoot;

    var _interface = new API({ apollo: apollo, apiRoot: apiRoot });

    return {
        forms: _interface.crud('/forms', ['get']),
        submissions: _interface.crud('/submissions', ['create'])
    };
};

exports.API = API;
exports.default = apiFactory;