'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-disable import/no-unresolved */

/**
 * this recaptcha class is responsible for driving recaptcha v3 spam check functionality. This consists of:
 *
 * - embedding a recaptcha v3 snippet into the page (if it hasn't already been injected)
 * - executing a recaptcha check and returning a token for verification by the submission endpoint
 */
var Recaptcha = function () {
    function Recaptcha(_ref) {
        var siteKey = _ref.siteKey;

        _classCallCheck(this, Recaptcha);

        this._siteKey = siteKey;
    }

    /**
     * injects the recaptcha snippet into the page IFF it hasn't already been injected
     */


    _createClass(Recaptcha, [{
        key: 'injectSnippet',
        value: function injectSnippet() {
            if (!document.getElementById('icarus-recaptcha')) {
                var script = document.createElement('script');
                script.src = 'https://www.google.com/recaptcha/api.js?render=' + this._siteKey;
                script.addEventListener('load', function (event) {
                    console.log('app.js file has been loaded');
                });

                document.body.appendChild(script);
            }
        }

        /**
         * runs background spam check on the session and returns a promise resolving with the token for verification on
         * the backend
         * @return `Promise` resolving with a token
         */

    }, {
        key: 'executeCheck',
        value: function executeCheck() {
            var _this = this;

            return new Promise(function (resolve, reject) {
                grecaptcha.ready(function () {
                    grecaptcha.execute(_this._siteKey, { action: 'submit' }).then(resolve);
                });
            });
        }
    }]);

    return Recaptcha;
}();

exports.default = Recaptcha;